/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2006,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#ifndef _LIB_GMATH_H_
#define _LIB_GMATH_H_		1

#ifdef __cplusplus
extern "C" {
#endif

#include "spec9_types.h"

/* Trig routines */
extern float cos8(float angle);
extern float cos14(float angle);
extern float cos18(float angle);
extern float sin8(float angle);
extern float sin14(float angle);
extern float sin18(float angle);
extern vector float cos8_v(vector float angle);
extern vector float cos14_v(vector float angle);
extern vector float cos18_v(vector float angle);
extern vector float sin8_v(vector float angle);
extern vector float sin14_v(vector float angle);
extern vector float sin18_v(vector float angle);


/* Pack/Unpacking routines */
extern unsigned int pack_color8(vector float rgba);
extern short pack_normal16(float normal);
extern unsigned int pack_rgba8(float red, float green, float blue, float alpha);
extern vector float unpack_color8(unsigned int rgba);
extern float unpack_normal16(short pack);
extern float unpack_rgba8(unsigned int rgba, int component);

extern double pack_normal16_v(vector float normal);
extern vector unsigned int pack_rgba8_v(vector float red, vector float green, vector float blue, vector float alpha);
extern vector float unpack_rgba8_v(vector unsigned int rgba, int component);
extern vector float unpack_normal16_v(double pack);

/* Specular lighting routines */
extern void set_spec_exponent9(spec9Exponent *exp, int exponent);
extern float spec9(float base, spec9Exponent *exp);
extern vector float spec9_v(vector float base, spec9Exponent *exp);

#ifdef __cplusplus
}
#endif
#endif /* _LIB_GMATH_H_ */
