/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef _conv_shuf_ub_h_
#define _conv_shuf_ub_h_

#include <vec_types.h>

/* Shuffle patterns for 'spreading' and 'packing' pixels to and
 * from vec_uint4 and vec_uchar16 form. 
 */

/* get pixel 0 from vec_uint4 */
static vec_uchar16 p0_shuf = (vec_uchar16) {
					 16, 17, 18, 0,
					 16, 17, 18, 1,
					 16, 17, 18, 2,
					 16, 17, 18, 3};

/* get pixel 1 from vec_uint4 */
static vec_uchar16 p1_shuf = (vec_uchar16) {
					 16, 17, 18, 4,
					 16, 17, 18, 5,
					 16, 17, 18, 6,
					 16, 17, 18, 7};

/* get pixel 2 from vec_uint4 */
static vec_uchar16 p2_shuf = (vec_uchar16) {
					 16, 17, 18,  8,
					 16, 17, 18,  9,
					 16, 17, 18, 10,
					 16, 17, 18, 11};

/* get pixel 3 from vec_uint4 */
static vec_uchar16 p3_shuf = (vec_uchar16) {
					 16, 17, 18, 12,
					 16, 17, 18, 13,
					 16, 17, 18, 14,
					 16, 17, 18, 15};

/* pack two pixels together */
static vec_uchar16 shuf_p2 = (vec_uchar16) {
					 3,  7, 11, 15,
					 19, 23, 27, 31,
					 0,  0,  0,  0,
					 0,  0,  0,  0};

/* pack four pixels together */
static vec_uchar16 shuf_p4 = (vec_uchar16) {
					 0,  1,  2,  3,
					 4,  5,  6,  7,
					 16, 17, 18, 19,
					 20, 21, 22, 23};

#endif /* _conv_shuf_ub_h_ */
