/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2006,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#ifndef _LIB_MATRIX_H_
#define _LIB_MATRIX_H_		1

#ifdef __cplusplus
extern "C" {
#endif

extern void frustum_matrix4x4(vector float *mOut, float left, float right, float bottom, float top, float near, float far);
extern void identity_matrix4x4(vector float *mOut);
extern int inverse_matrix4x4(vector float *mOut, vector float *mIn);
extern void mult_matrix4x4(vector float *mOut, vector float *m1, vector float *m2);
extern vector float mult_quat(vector float q1, vector float q2);
extern void ortho_matrix4x4(vector float *mOut, float left, float right, float bottom, float top, float near, float far);
extern void perspective_matrix4x4(vector float *mOut, float fovy, float aspect, float near, float far);
extern void quat_to_rot_matrix4x4(vector float *mOut, vector float quaternion);
extern vector float rot_matrix4x4_to_quat(vector float *rotMatrix);
extern void rotate_matrix4x4(vector float *mOut, vector float vec, float angle);
extern void scale_matrix4x4(vector float *mOut, vector float *mIn, vector float scales);
extern vector float slerp_quat(vector float q1, vector float q2, float t);
extern void splat_matrix4x4(vector float *mOut, const vector float *mIn);
extern void transpose_matrix4x4(vector float *mOut, vector float *mIn);


#ifdef __SPU__
extern void mult_matrix4x4_d(vector double *mOut, vector double *m1, vector double *m2);
extern void cast_matrix4x4_to_dbl(vector double *mOut, vector float *mIn);
extern void cast_matrix4x4_to_flt(vector float *mOut, vector double *mIn);
#endif /* __SPU__ */

#ifdef __cplusplus
}
#endif

#endif /* _LIB_MATRIX_H_ */
